#include "unary_arithmetic_filter.hpp"
#include "workflow_graph.hpp"
namespace xios
{
  CUnaryArithmeticFilter::CUnaryArithmeticFilter(CGarbageCollector& gc, const std::string& op)
    : CFilter(gc, 1, this)
    , op(operatorExpr.getOpField(op))
  { 
    StdString input_op_expression=op;
    if(input_op_expression == "neg")
      op_expression = "-";
    else if(input_op_expression == "sin")
      op_expression = "sin";
    else if(input_op_expression == "cos")
      op_expression = "cos";
    else if(input_op_expression == "tan")
      op_expression = "tan";
    else if(input_op_expression == "exp")
      op_expression = "exp";
    else if(input_op_expression == "log")
      op_expression = "log";
    else if(input_op_expression == "log10")
      op_expression = "log10";
    else if(input_op_expression == "sqrt")
      op_expression = "sqrt";
    else
      op_expression = " ";
  };

  CDataPacketPtr CUnaryArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
  {
    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;

    if(building_graph)
    {
      this->filterID = InvalidableObject::filterIdGenerator++;
      int edgeID = InvalidableObject::edgeIdGenerator++;
      
      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;

      std::cout<<"CunaryArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;

      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "F Filter";
      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2;
      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;

      if(CWorkflowGraph::build_begin)
      {

        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);

        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
      }
      else CWorkflowGraph::build_begin = true;
  
    }

    CDataPacketPtr packet(new CDataPacket);
    packet->date = data[0]->date;
    packet->timestamp = data[0]->timestamp;
    packet->status = data[0]->status;
    packet->field = this->field;

    if (packet->status == CDataPacket::NO_ERROR)
      packet->data.reference(op(data[0]->data));

    if(building_graph) packet->src_filterID = this->filterID;

    return packet;
  }
} // namespace xios
